diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekex_key.c openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex_key.c
--- openssl-1.0.1f/crypto/rlwekex/rlwekex_key.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex_key.c	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,629 @@
+/* crypto/rlwekex/rlwekex_key.c */
+
+#include <string.h>
+#include <openssl/rand.h>
+#include "rlwekex_locl.h"
+
+#define RANDOMNESS_AESCTR
+
+#ifdef RANDOMNESS_AESCTR
+#include <openssl/aes.h>
+#define RANDOM_VARS \
+	AES_KEY aes_key; \
+	unsigned char aes_key_bytes[16]; \
+	RAND_bytes(aes_key_bytes, 16); \
+	AES_set_encrypt_key(aes_key_bytes, 128, &aes_key); \
+	unsigned char aes_ivec[AES_BLOCK_SIZE]; \
+	memset(aes_ivec, 0, AES_BLOCK_SIZE); \
+	unsigned char aes_ecount_buf[AES_BLOCK_SIZE]; \
+	memset(aes_ecount_buf, 0, AES_BLOCK_SIZE); \
+	unsigned int aes_num = 0; \
+	unsigned char aes_in[AES_BLOCK_SIZE]; \
+	memset(aes_in, 0, AES_BLOCK_SIZE);
+#define RANDOM8   ((uint8_t) randomplease(&aes_key, aes_ivec, aes_ecount_buf, &aes_num, aes_in))
+#define RANDOM32 ((uint32_t) randomplease(&aes_key, aes_ivec, aes_ecount_buf, &aes_num, aes_in))
+#define RANDOM64 ((uint64_t) randomplease(&aes_key, aes_ivec, aes_ecount_buf, &aes_num, aes_in))
+
+uint64_t randomplease(AES_KEY *aes_key, unsigned char aes_ivec[AES_BLOCK_SIZE],
+                      unsigned char aes_ecount_buf[AES_BLOCK_SIZE],
+                      unsigned int *aes_num, unsigned char aes_in[AES_BLOCK_SIZE]) {
+	uint64_t out;
+	AES_ctr128_encrypt(aes_in, (unsigned char *) &out, 8, aes_key, aes_ivec, aes_ecount_buf, aes_num);
+	return out;
+}
+#endif
+
+#ifdef RANDOMNESS_RCFOUR
+#include <openssl/rc4.h>
+#define RANDOM_VARS \
+	RC4_KEY rc4_key; \
+	unsigned char rc4_key_bytes[16]; \
+	RAND_bytes(rc4_key_bytes, 16); \
+	RC4_set_key(&rc4_key, 16, rc4_key_bytes);
+
+#define RANDOM8   ((uint8_t) randomplease(&rc4_key))
+#define RANDOM32 ((uint32_t) randomplease(&rc4_key))
+#define RANDOM64 ((uint64_t) randomplease(&rc4_key))
+
+uint64_t randomplease(RC4_KEY *rc4_key) {
+	uint64_t b;
+	uint64_t z = (uint64_t) 0;
+	RC4(rc4_key, 8, (unsigned char *) &z, (unsigned char *) &b);
+	return b;
+}
+
+#endif
+
+#ifdef RANDOMNESS_RAND_bytes
+#define RANDOM_VARS
+#define RANDOM8 (random8())
+#define RANDOM32 (random32())
+#define RANDOM64 (random64())
+
+uint8_t random8() {
+	uint8_t b;
+	int r = RAND_bytes((unsigned char *) &b, 1);
+	if (r != 1) {
+		RLWEKEXerr(RLWEKEX_F_RANDOM8, RLWEKEX_R_RANDOM_FAILED);
+	}
+	return b;
+}
+uint32_t random32() {
+	uint32_t b;
+	int r = RAND_bytes((unsigned char *) &b, 4);
+	if (r != 1) {
+		RLWEKEXerr(RLWEKEX_F_RANDOM32, RLWEKEX_R_RANDOM_FAILED);
+	}
+	return b;
+}
+uint64_t random64() {
+	uint64_t b;
+	int r = RAND_bytes((unsigned char *) &b, 8);
+	if (r != 1) {
+		RLWEKEXerr(RLWEKEX_F_RANDOM64, RLWEKEX_R_RANDOM_FAILED);
+	}
+	return b;
+}
+#endif
+
+#include "rlwekexlib/fft.c"
+#include "rlwekexlib/rlwe.c"
+#include "rlwekexlib/rlwe_a.h"
+
+/* Allocate and deallocate auxiliary variables (context) data structure */
+
+RLWE_CTX *RLWE_CTX_new(void) {
+	RLWE_CTX *ret;
+	ret = (RLWE_CTX *)OPENSSL_malloc(sizeof(RLWE_CTX));
+	if (ret == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_CTX_NEW, ERR_R_MALLOC_FAILURE);
+		return (NULL);
+	}
+	ret->fft_ctx = (FFT_CTX *)OPENSSL_malloc(sizeof(FFT_CTX));
+	if (ret->fft_ctx == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_CTX_NEW, ERR_R_MALLOC_FAILURE);
+		return (NULL);
+	}
+	if (FFT_CTX_init(ret->fft_ctx) == 0) {
+		goto err;
+	}
+	return (ret);
+  err:
+  	FFT_CTX_free(ret->fft_ctx);
+  	OPENSSL_free(ret->fft_ctx);
+  	OPENSSL_free(ret);
+  	return (NULL);
+}
+
+void RLWE_CTX_free(RLWE_CTX *r) {
+	if (r == NULL) return;
+	FFT_CTX_clear(r->fft_ctx);
+	FFT_CTX_free(r->fft_ctx);
+	OPENSSL_free(r->fft_ctx);
+	OPENSSL_cleanse((void *)r, sizeof(RLWE_CTX));
+	OPENSSL_free(r);
+}
+
+/* Allocate and deallocate public parameters data structure */
+
+RLWE_PARAM *RLWE_PARAM_new(void) {
+	RLWE_PARAM *ret;
+
+	ret = (RLWE_PARAM *)OPENSSL_malloc(sizeof(RLWE_PARAM));
+	if (ret == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_PARAM_NEW, ERR_R_MALLOC_FAILURE);
+		return (NULL);
+	}
+
+	ret->version = 1;
+	ret->flags = 0;
+	ret->references = 1;
+
+	ret->a = (uint32_t *) rlwe_a;
+
+	return (ret);
+}
+
+void RLWE_PARAM_free(RLWE_PARAM *r) {
+	int i;
+
+	if (r == NULL) return;
+
+	i = CRYPTO_add(&r->references, -1, CRYPTO_LOCK_EC);
+#ifdef REF_PRINT
+	REF_PRINT("RLWE_PARAM", r);
+#endif
+	if (i > 0) return;
+#ifdef REF_CHECK
+	if (i < 0) {
+		fprintf(stderr, "RLWE_PARAM_free, bad reference count\n");
+		abort();
+	}
+#endif
+
+	OPENSSL_cleanse((void *)r, sizeof(RLWE_PARAM));
+
+	OPENSSL_free(r);
+}
+
+/* Allocate and deallocate public key data structure */
+
+RLWE_PUB *RLWE_PUB_new(void) {
+	RLWE_PUB *ret;
+
+	ret = (RLWE_PUB *)OPENSSL_malloc(sizeof(RLWE_PUB));
+	if (ret == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_PUB_NEW, ERR_R_MALLOC_FAILURE);
+		return (NULL);
+	}
+
+	ret->version = 1;
+	ret->flags = 0;
+	ret->references = 1;
+
+	ret->param = NULL;
+	ret->b = (uint32_t *) OPENSSL_malloc (1024 * sizeof (uint32_t));
+
+	return (ret);
+}
+
+RLWE_PUB *RLWE_PUB_copy(RLWE_PUB *dest, const RLWE_PUB *src) {
+	if (dest == NULL || src == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_PUB_COPY, ERR_R_PASSED_NULL_PARAMETER);
+		return NULL;
+	}
+
+	/* copy the parameters; this takes advantage of the fact that we only currently
+	   support one set of parameters */
+	if (!dest->param) {
+		dest->param = RLWE_PARAM_new();
+	}
+
+	/* copy the public key */
+	if (src->b) {
+		if (!dest->b) {
+			dest->b = OPENSSL_malloc(1024 * sizeof (uint32_t));
+		}
+		memcpy(dest->b, src->b, 1024 * sizeof (uint32_t));
+	}
+
+	/* copy the rest */
+	dest->version   = src->version;
+	dest->flags = src->flags;
+
+	return dest;
+}
+
+void RLWE_PUB_free(RLWE_PUB *r) {
+	int i;
+
+	if (r == NULL) return;
+
+	i = CRYPTO_add(&r->references, -1, CRYPTO_LOCK_EC);
+#ifdef REF_PRINT
+	REF_PRINT("RLWE_PUB", r);
+#endif
+	if (i > 0) return;
+#ifdef REF_CHECK
+	if (i < 0) {
+		fprintf(stderr, "RLWE_PUB_free, bad reference count\n");
+		abort();
+	}
+#endif
+
+	RLWE_PARAM_free(r->param);
+
+	OPENSSL_cleanse(r->b, 1024 * sizeof (uint32_t));
+	OPENSSL_free(r->b);
+
+	OPENSSL_cleanse((void *)r, sizeof(RLWE_PUB));
+
+	OPENSSL_free(r);
+}
+
+/* Allocate and deallocate public key / private key pair data structure */
+
+RLWE_PAIR *RLWE_PAIR_new(void) {
+	RLWE_PAIR *ret;
+
+	ret = (RLWE_PAIR *)OPENSSL_malloc(sizeof(RLWE_PAIR));
+	if (ret == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_PAIR_NEW, ERR_R_MALLOC_FAILURE);
+		return (NULL);
+	}
+
+	ret->version = 1;
+	ret->flags = 0;
+	ret->references = 1;
+
+	ret->pub = NULL;
+
+	ret->s = (uint32_t *) OPENSSL_malloc (1024 * sizeof (uint32_t));
+	ret->e = (uint32_t *) OPENSSL_malloc (1024 * sizeof (uint32_t));
+
+	return (ret);
+}
+
+RLWE_PAIR *RLWE_PAIR_copy(RLWE_PAIR *dest, const RLWE_PAIR *src) {
+	if (dest == NULL || src == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_PAIR_COPY, ERR_R_PASSED_NULL_PARAMETER);
+		return NULL;
+	}
+
+	/* copy the public key */
+	if (src->pub) {
+		if (dest->pub)
+			RLWE_PUB_free(dest->pub);
+		dest->pub = RLWE_PUB_new();
+		if (dest->pub == NULL)
+			return NULL;
+		if (!RLWE_PUB_copy(dest->pub, src->pub))
+			return NULL;
+	}
+
+	/* copy the private key */
+	if (src->s) {
+		if (!dest->s) {
+			dest->s = OPENSSL_malloc(1024 * sizeof (uint32_t));
+		}
+		memcpy(dest->s, src->s, 1024 * sizeof (uint32_t));
+	}
+	if (src->e) {
+		if (!dest->e) {
+			dest->e = OPENSSL_malloc(1024 * sizeof (uint32_t));
+		}
+		memcpy(dest->e, src->e, 1024 * sizeof (uint32_t));
+	}
+
+	/* copy the rest */
+	dest->version   = src->version;
+	dest->flags = src->flags;
+
+	return dest;
+}
+
+RLWE_PAIR *RLWE_PAIR_dup(const RLWE_PAIR *pair) {
+	RLWE_PAIR *ret = RLWE_PAIR_new();
+	if (ret == NULL)
+		return NULL;
+	if (RLWE_PAIR_copy(ret, pair) == NULL) {
+		RLWE_PAIR_free(ret);
+		return NULL;
+	}
+	return ret;
+}
+
+void RLWE_PAIR_free(RLWE_PAIR *r) {
+	int i;
+
+	if (r == NULL) return;
+
+	i = CRYPTO_add(&r->references, -1, CRYPTO_LOCK_EC);
+#ifdef REF_PRINT
+	REF_PRINT("RLWE_PAIR", r);
+#endif
+	if (i > 0) return;
+#ifdef REF_CHECK
+	if (i < 0) {
+		fprintf(stderr, "RLWE_PAIR_free, bad reference count\n");
+		abort();
+	}
+#endif
+
+	RLWE_PUB_free(r->pub);
+
+	OPENSSL_cleanse(r->s, 1024 * sizeof (uint32_t));
+	OPENSSL_free(r->s);
+	OPENSSL_cleanse(r->e, 1024 * sizeof (uint32_t));
+	OPENSSL_free(r->e);
+
+	OPENSSL_cleanse((void *)r, sizeof(RLWE_PAIR));
+
+	OPENSSL_free(r);
+}
+
+/* Allocate and deallocate reconciliation data structure */
+
+RLWE_REC *RLWE_REC_new(void) {
+	RLWE_REC *ret;
+
+	ret = (RLWE_REC *)OPENSSL_malloc(sizeof(RLWE_REC));
+	if (ret == NULL) {
+		RLWEKEXerr(RLWEKEX_F_RLWE_REC_NEW, ERR_R_MALLOC_FAILURE);
+		return (NULL);
+	}
+
+	ret->version = 1;
+	ret->flags = 0;
+	ret->references = 1;
+
+	ret->c = (uint64_t *) malloc (16 * sizeof (uint64_t));
+
+	return (ret);
+}
+
+void RLWE_REC_free(RLWE_REC *r) {
+	int i;
+
+	if (r == NULL) return;
+
+	i = CRYPTO_add(&r->references, -1, CRYPTO_LOCK_EC);
+#ifdef REF_PRINT
+	REF_PRINT("RLWE_REC", r);
+#endif
+	if (i > 0) return;
+#ifdef REF_CHECK
+	if (i < 0) {
+		fprintf(stderr, "RLWE_REC_free, bad reference count\n");
+		abort();
+	}
+#endif
+
+	OPENSSL_cleanse(r->c, 16 * sizeof (uint64_t));
+	OPENSSL_free(r->c);
+
+	OPENSSL_cleanse((void *)r, sizeof(RLWE_REC));
+
+	OPENSSL_free(r);
+}
+
+/* Generate key pair */
+
+int RLWE_PAIR_generate_key(RLWE_PAIR *key, RLWE_CTX *ctx) {
+	int	ok = 0;
+
+	key->pub = RLWE_PUB_new();
+	if (key->pub == NULL) {
+		goto err;
+	}
+
+	key->pub->param = RLWE_PARAM_new();
+	if (key->pub->param == NULL) {
+		goto err;
+	}
+
+#if CONSTANT_TIME
+	sample_ct(key->s);
+	sample_ct(key->e);
+#else
+	sample(key->s);
+	sample(key->e);
+#endif
+	key_gen(key->pub->b, key->pub->param->a, key->s, key->e, ctx->fft_ctx);
+
+	ok = 1;
+	goto err;
+
+err:
+	return (ok);
+}
+
+/* Convert public keys data structures from/to binary */
+
+RLWE_PUB *o2i_RLWE_PUB(RLWE_PUB **pub, const unsigned char *in, long len) {
+	int i;
+	if (pub == NULL) {
+		RLWEKEXerr(RLWEKEX_F_O2I_RLWE_PUB, ERR_R_PASSED_NULL_PARAMETER);
+		return 0;
+	}
+	if (*pub == NULL && (*pub = RLWE_PUB_new()) == NULL) {
+		RLWEKEXerr(RLWEKEX_F_O2I_RLWE_PUB, ERR_R_MALLOC_FAILURE);
+		return 0;
+	}
+
+	if (len != 1024 * 4) {
+		RLWEKEXerr(RLWEKEX_F_O2I_RLWE_PUB, RLWEKEX_R_INVALID_LENGTH);
+		return 0;
+	}
+
+	for (i = 0; i < 1024; i++) {
+		(*pub)->b[i] = (((uint32_t) in[4 * i + 0]) << 24) |
+		               (((uint32_t) in[4 * i + 1]) << 16) |
+		               (((uint32_t) in[4 * i + 2]) << 8) |
+		               ( (uint32_t) in[4 * i + 3]);
+	}
+
+	return *pub;
+}
+
+int i2o_RLWE_PUB(RLWE_PUB *pub, unsigned char **out) {
+	size_t buf_len = 0;
+	int new_buffer = 0, i;
+
+	if (pub == NULL) {
+		RLWEKEXerr(RLWEKEX_F_I2O_RLWE_PUB, ERR_R_PASSED_NULL_PARAMETER);
+		return 0;
+	}
+
+	buf_len = 1024 * 4;
+
+	if (out == NULL || buf_len == 0)
+		/* out == NULL => just return the length of the octet string */
+		return buf_len;
+
+	if (*out == NULL) {
+		if ((*out = OPENSSL_malloc(buf_len)) == NULL) {
+			RLWEKEXerr(RLWEKEX_F_I2O_RLWE_PUB, ERR_R_MALLOC_FAILURE);
+			return 0;
+		}
+		new_buffer = 1;
+	}
+
+	for (i = 0; i < 1024; i++) {
+		(*out)[4 * i + 0] = (unsigned char)  (pub->b[i] >> 24);
+		(*out)[4 * i + 1] = (unsigned char) ((pub->b[i] >> 16) & 0xff);
+		(*out)[4 * i + 2] = (unsigned char) ((pub->b[i] >>  8) & 0xff);
+		(*out)[4 * i + 3] = (unsigned char) ( pub->b[i]        & 0xff);
+	}
+
+	if (!new_buffer)
+		*out += buf_len;
+	return buf_len;
+}
+
+/* Convert reconciliation data structure from/to binary */
+
+RLWE_REC *o2i_RLWE_REC(RLWE_REC **rec, const unsigned char *in, long len) {
+
+	if (rec == NULL) {
+		RLWEKEXerr(RLWEKEX_F_O2I_RLWE_REC, ERR_R_PASSED_NULL_PARAMETER);
+		return 0;
+	}
+	if (*rec == NULL && (*rec = RLWE_REC_new()) == NULL) {
+		RLWEKEXerr(RLWEKEX_F_O2I_RLWE_REC, ERR_R_MALLOC_FAILURE);
+		return 0;
+	}
+
+	if (len != 16 * 8) {
+		RLWEKEXerr(RLWEKEX_F_O2I_RLWE_REC, RLWEKEX_R_INVALID_LENGTH);
+		return 0;
+	}
+
+	memcpy((unsigned char *) ((*rec)->c), in, len);
+
+	return *rec;
+}
+
+int i2o_RLWE_REC(RLWE_REC *rec, unsigned char **out) {
+	size_t buf_len = 0;
+	int new_buffer = 0;
+
+	if (rec == NULL) {
+		RLWEKEXerr(RLWEKEX_F_I2O_RLWE_REC, ERR_R_PASSED_NULL_PARAMETER);
+		return 0;
+	}
+
+	buf_len = 16 * 8;
+
+	if (out == NULL || buf_len == 0)
+		/* out == NULL => just return the length of the octet string */
+		return buf_len;
+
+	if (*out == NULL) {
+		if ((*out = OPENSSL_malloc(buf_len)) == NULL) {
+			RLWEKEXerr(RLWEKEX_F_I2O_RLWE_REC, ERR_R_MALLOC_FAILURE);
+			return 0;
+		}
+		new_buffer = 1;
+	}
+
+	memcpy(*out, (unsigned char *) rec->c, buf_len);
+
+	if (!new_buffer)
+		*out += buf_len;
+	return buf_len;
+}
+
+/* Get public key from a key pair */
+RLWE_PUB *RLWE_PAIR_get_publickey(RLWE_PAIR *pair) {
+	if (pair == NULL) return NULL;
+	return pair->pub;
+}
+
+/* Does private key exist? */
+int RLWE_PAIR_has_privatekey(RLWE_PAIR *pair) {
+	return (pair->s != NULL) && (pair->e != NULL);
+}
+
+/* Compute shared secret values */
+int RLWEKEX_compute_key_alice(void *out, size_t outlen, const RLWE_PUB *peer_pub_key,  const RLWE_REC *peer_reconciliation,
+                              const RLWE_PAIR *priv_pub_key, void *(*KDF)(const void *in, size_t inlen, void *out, size_t *outlen), RLWE_CTX *ctx) {
+
+	int ret = -1;
+
+	uint32_t *w = (uint32_t *) OPENSSL_malloc (1024 * sizeof (uint32_t));
+	uint64_t *ka  = (uint64_t *) OPENSSL_malloc (16 * sizeof (uint64_t));
+
+	FFT_mul(w, peer_pub_key->b, priv_pub_key->s, ctx->fft_ctx);
+#if CONSTANT_TIME
+	rec_ct (ka, w, peer_reconciliation->c);
+#else
+	rec (ka, w, peer_reconciliation->c);
+#endif
+
+	if (KDF != 0) {
+		if (KDF((unsigned char *) ka, 16 * sizeof(uint64_t), out, &outlen) == NULL) {
+			RLWEKEXerr(RLWEKEX_F_RLWEKEX_COMPUTE_KEY_ALICE, RLWEKEX_R_KDF_FAILED);
+			goto err;
+		}
+		ret = outlen;
+	} else {
+		/* no KDF, just copy as much as we can */
+		if (outlen > 16 * sizeof(uint64_t))
+			outlen = 16 * sizeof(uint64_t);
+		memcpy(out, (unsigned char *) ka, outlen);
+		ret = outlen;
+	}
+
+err:
+	if (w) OPENSSL_free(w);
+	if (ka) OPENSSL_free(ka);
+	return (ret);
+
+}
+
+int RLWEKEX_compute_key_bob(void *out, size_t outlen, RLWE_REC *reconciliation, const RLWE_PUB *peer_pub_key,  const RLWE_PAIR *priv_pub_key,
+                            void *(*KDF)(const void *in, size_t inlen, void *out, size_t *outlen), RLWE_CTX *ctx) {
+
+	int ret = -1;
+
+	uint32_t *v  = (uint32_t *) OPENSSL_malloc (1024 * sizeof (uint32_t));
+	uint64_t *kb = (uint64_t *) OPENSSL_malloc (16 * sizeof (uint64_t));
+
+	uint32_t *eprimeprime = (uint32_t *) OPENSSL_malloc (1024 * sizeof (uint32_t));
+#if CONSTANT_TIME
+	sample_ct(eprimeprime);
+#else
+	sample(eprimeprime);
+#endif
+	key_gen(v, peer_pub_key->b, priv_pub_key->s, eprimeprime, ctx->fft_ctx);
+	OPENSSL_free(eprimeprime);
+
+#if CONSTANT_TIME
+	crossround2_ct(reconciliation->c, v);
+	round2_ct(kb, v);
+#else
+	crossround2(reconciliation->c, v);
+	round2(kb, v);
+#endif
+
+	if (KDF != 0) {
+		if (KDF((unsigned char *) kb, 16 * sizeof(uint64_t), out, &outlen) == NULL) {
+			RLWEKEXerr(RLWEKEX_F_RLWEKEX_COMPUTE_KEY_BOB, RLWEKEX_R_KDF_FAILED);
+			goto err;
+		}
+		ret = outlen;
+	} else {
+		/* no KDF, just copy as much as we can */
+		if (outlen > 16 * sizeof(uint64_t))
+			outlen = 16 * sizeof(uint64_t);
+		memcpy(out, (unsigned char *) kb, outlen);
+		ret = outlen;
+	}
+
+err:
+	if (v) OPENSSL_free(v);
+	if (kb) OPENSSL_free(kb);
+	return (ret);
+
+}
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekex_locl.h openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex_locl.h
--- openssl-1.0.1f/crypto/rlwekex/rlwekex_locl.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex_locl.h	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,57 @@
+/* crypto/rlwekex/rlwekex_locl.h */
+
+#ifndef HEADER_RLWEKEX_LOCL_H
+#define HEADER_RLWEKEX_LOCL_H
+
+#include <openssl/rlwekex.h>
+#include "rlwekexlib/fft.h"
+
+#define CONSTANT_TIME 1
+
+#ifdef  __cplusplus
+extern "C" {
+#endif
+
+struct rlwe_param_st {
+	int version;
+	uint32_t *a;
+	int references;
+	int	flags;
+};
+
+struct rlwe_pub_st {
+	int version;
+	RLWE_PARAM *param;
+	uint32_t *b;
+	int references;
+	int	flags;
+};
+
+struct rlwe_pair_st {
+	int version;
+	RLWE_PUB *pub;
+	uint32_t *s;
+	uint32_t *e;
+	int references;
+	int	flags;
+};
+
+struct rlwe_rec_st {
+	int version;
+	uint64_t *c;
+	int references;
+	int	flags;
+};
+
+struct rlwe_ctx_st {
+	int version;
+	FFT_CTX *fft_ctx;
+	int references;
+	int	flags;
+};
+
+#ifdef  __cplusplus
+}
+#endif
+
+#endif /* HEADER_RLWEKEX_LOCL_H */
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/LICENSE openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/LICENSE
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/LICENSE	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/LICENSE	2014-10-16 12:53:58.000000000 +0200
@@ -0,0 +1,24 @@
+This is free and unencumbered software released into the public domain.
+
+Anyone is free to copy, modify, publish, use, compile, sell, or
+distribute this software, either in source code form or as a compiled
+binary, for any purpose, commercial or non-commercial, and by any
+means.
+
+In jurisdictions that recognize copyright laws, the author or authors
+of this software dedicate any and all copyright interest in the
+software to the public domain. We make this dedication for the benefit
+of the public at large and to the detriment of our heirs and
+successors. We intend this dedication to be an overt act of
+relinquishment in perpetuity of all present and future rights to this
+software under copyright law.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
+OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+OTHER DEALINGS IN THE SOFTWARE.
+
+For more information, please refer to <http://unlicense.org/>
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/fft.c openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/fft.c
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/fft.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/fft.c	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,280 @@
+/* This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * See LICENSE for complete information.
+ */
+
+#include <stdlib.h>
+#include <string.h>
+
+#include "fft.h"
+
+/* Reduction modulo p = 2^32 - 1.
+ * This is not a prime since 2^32-1 = (2^1+1)*(2^2+1)*(2^4+1)*(2^8+1)*(2^16+1).
+ * But since 2 is a unit in Z/pZ we can use it for computing FFTs in
+ * Z/pZ[X]/(X^(2^7)+1)
+ */
+
+/* Caution:
+ * We use a redundant representation where the integer 0 is represented both
+ * by 0 and 2^32-1.
+ * This approach follows the describtion from the paper:
+ * Joppe W. Bos, Craig Costello, Huseyin Hisil, and Kristin Lauter: Fast Cryptography in Genus 2
+ * EUROCRYPT 2013, Lecture Notes in Computer Science 7881, pp. 194-210, Springer, 2013.
+ * More specifically see: Section 3 related to Modular Addition/Subtraction.
+ */
+
+/* Compute: c = (a+b) mod (2^32-1)
+ * Let, t = a+b = t_1*2^32 + t0, where 0 <= t_1 <= 1, 0 <= t_0 < 2^32.
+ * Then t mod (2^32-1) = t0 + t1 */
+
+/* NOTE:
+ * Implementing this arithmetic in asm might significantly
+ * increase performance.
+ */
+
+#define modadd(c,a,b) \
+do { \
+  uint32_t _t = a+b; \
+  c = _t + (_t < a); \
+} while (0)
+
+#define modsub(c,a,b) c = (a-b) - (b > a)
+
+#define modmul(c,a,b) \
+do { \
+  uint64_t _T = (uint64_t) a * (uint64_t) b; \
+  modadd (c, ((uint32_t) _T), ((uint32_t) ((uint64_t) _T >> (uint64_t) 32))); \
+} while (0)
+
+
+#define modmuladd(c,a,b) \
+do { \
+  uint64_t _T = (uint64_t) a * (uint64_t) b + c; \
+  modadd (c, ((uint32_t) _T), ((uint32_t) ((uint64_t) _T >> (uint64_t) 32))); \
+} while (0)
+
+#define div2(c,a) c= (uint32_t) (((uint64_t) (a) + (uint64_t) ((uint32_t)(0-((a)&1))&0xFFFFFFFF))>>1)
+#define normalize(c,a) c = (a) + ((a) == 0xFFFFFFFF)
+
+/* Define the basic building blocks for the FFT. */
+#define DATATYPE uint32_t
+
+#define SET_ZERO(x) (x)=0
+#define add(c,a,b) modadd(c,a,b)
+#define sub(c,a,b) modsub(c,a,b)
+#define mul(c,a,b) modmul(c,a,b)
+#define moddiv2(c,a)  normalize(c,a); div2(c,c)
+#define neg(c,a)   (c)=0xFFFFFFFF-(a); normalize(c,c)
+#define squ(c,a)   mul(c,a,a)
+#define set(c,a)   (c)=(a)
+
+/* Reverse the bits, approach from "Bit Twiddling Hacks"
+ * See: https://graphics.stanford.edu/~seander/bithacks.html
+ */
+static uint32_t reverse(uint32_t x) {
+	x = (((x & 0xaaaaaaaa) >> 1) | ((x & 0x55555555) << 1));
+	x = (((x & 0xcccccccc) >> 2) | ((x & 0x33333333) << 2));
+	x = (((x & 0xf0f0f0f0) >> 4) | ((x & 0x0f0f0f0f) << 4));
+	x = (((x & 0xff00ff00) >> 8) | ((x & 0x00ff00ff) << 8));
+	return ((x >> 16) | (x << 16));
+}
+
+/* Nussbaumer approach, see:
+ * H. J. Nussbaumer. Fast polynomial transform algorithms for digital convolution. Acoustics, Speech and
+ * Signal Processing, IEEE Transactions on, 28(2):205{215, 1980
+ * We followed the describtion from Knuth:
+ * D. E. Knuth. Seminumerical Algorithms. The Art of Computer Programming. Addison-Wesley, Reading,
+ * Massachusetts, USA, 3rd edition, 1997
+ * Exercise Exercise 4.6.4.59.
+ */
+
+static void naive(DATATYPE *z, const DATATYPE *x, const DATATYPE *y, unsigned int n) {
+	unsigned int i, j, k;
+	DATATYPE A, B;
+
+	for (i = 0; i < n; i++) {
+		SET_ZERO(B);
+
+		mul(A, x[0], y[i]);
+
+		for (j = 1; j <= i; j++) {
+			modmuladd(A, x[j], y[i - j]);
+		}
+
+		for (k = 1; j < n; j++, k++) {
+			modmuladd(B, x[j], y[n - k]);
+		}
+		sub(z[i], A, B);
+	}
+}
+
+static void nussbaumer_fft(DATATYPE *z, const DATATYPE *x, const DATATYPE *y, FFT_CTX *ctx) {
+	DATATYPE **X1;
+	DATATYPE **Y1;
+	DATATYPE **Z1;
+	DATATYPE *T1;
+	unsigned int i;
+	int j;
+
+	X1 = (DATATYPE **) ctx->x1;
+	Y1 = (DATATYPE **) ctx->y1;
+
+	for (i = 0; i < 32; i++) {
+		for (j = 0; j < 32; j++) {
+			set(X1[i][j], x[32 * j + i]);
+			set(X1[i + 32][j], x[32 * j + i]);
+
+			set(Y1[i][j], y[32 * j + i]);
+			set(Y1[i + 32][j], y[32 * j + i]);
+		}
+	}
+
+	Z1 = (DATATYPE **) ctx->z1;
+	T1 = (DATATYPE *) ctx->t1;
+
+	for (j = 4; j >= 0; j--) {
+		for (i = 0; i < (1U << (5 - j)); i++) {
+			unsigned int t, ssr = reverse(i);
+			for (t = 0; t < (1U << j); t++) {
+				unsigned int s, sr, I, L, a;
+				s = i;
+				sr = (ssr >> (32 - 5 + j));
+				sr <<= j;
+				s <<= (j + 1);
+
+				// X_i(w) = X_i(w) + w^kX_l(w) can be computed as
+				// X_ij = X_ij - X_l(j-k+r)  for  0 <= j < k
+				// X_ij = X_ij + X_l(j-k)    for  k <= j < r
+				I = s + t, L = s + t + (1 << j);
+
+				for (a = sr; a < 32; a++) {
+					set(T1[a], X1[L][a - sr]);
+				}
+				for (a = 0; a < sr; a++) {
+					neg(T1[a], X1[L][32 + a - sr]);
+				}
+
+				for (a = 0; a < 32; a++) {
+					sub(X1[L][a], X1[I][a], T1[a]);
+					add(X1[I][a], X1[I][a], T1[a]);
+				}
+
+				for (a = sr; a < 32; a++) {
+					set(T1[a], Y1[L][a - sr]);
+				}
+				for (a = 0; a < sr; a++) {
+					neg(T1[a], Y1[L][32 + a - sr]);
+				}
+
+				for (a = 0; a < 32; a++) {
+					sub(Y1[L][a], Y1[I][a], T1[a]);
+					add(Y1[I][a], Y1[I][a], T1[a]);
+				}
+			}
+		}
+	}
+
+	for (i = 0; i < 2 * 32; i++) {
+		naive(Z1[i], X1[i], Y1[i], 32);
+	}
+
+	for (j = 0; j <= (int) 5; j++) {
+		for (i = 0; i < (1U << (5 - j)); i++) {
+			unsigned int t, ssr = reverse(i);
+			for (t = 0; t < (1U << j); t++) {
+				unsigned int s, sr, A, B, a;
+				s = i;
+				sr = (ssr >> (32 - 5 + j));
+				sr <<= j;
+				s <<= (j + 1);
+
+				A = s + t;
+				B = s + t + (1 << j);
+				for (a = 0; a < 32; a++) {
+					sub(T1[a], Z1[A][a], Z1[B][a]);
+					moddiv2(T1[a], T1[a]);
+					add(Z1[A][a], Z1[A][a], Z1[B][a]);
+					moddiv2(Z1[A][a], Z1[A][a]);
+				}
+
+				// w^{-(r/m)s'} (Z_{s+t}(w)-Z_{s+t+2^j}(w))
+				for (a = 0; a < 32 - sr; a++) {
+					set(Z1[B][a], T1[a + sr]);
+				}
+				for (a = 32 - sr; a < 32; a++) {
+					neg(Z1[B][a], T1[a - (32 - sr)]);
+				}
+			}
+		}
+	}
+
+	for (i = 0; i < 32; i++) {
+		sub(z[i], Z1[i][0], Z1[32 + i][32 - 1]);
+		for (j = 1; j < 32; j++) {
+			add(z[32 * j + i], Z1[i][j], Z1[32 + i][j - 1]);
+		}
+	}
+}
+
+void FFT_mul(uint32_t *z, const uint32_t *x, const uint32_t *y, FFT_CTX *ctx) {
+	nussbaumer_fft(z, x, y, ctx);
+}
+
+void FFT_add(uint32_t *z, const uint32_t *x, const uint32_t *y) {
+	int i;
+	for (i = 0; i < 1024; i++) {
+		add(z[i], x[i], y[i]);
+	}
+}
+
+int FFT_CTX_init(FFT_CTX *ctx) {
+	ctx->x1 = (uint32_t **) malloc(64 * sizeof(uint32_t *));
+	ctx->y1 = (uint32_t **) malloc(64 * sizeof(uint32_t *));
+	ctx->z1 = (uint32_t **) malloc(64 * sizeof(uint32_t *));
+	ctx->t1 = (uint32_t *) malloc(64 * sizeof(uint32_t));
+	if (ctx->x1 == NULL || ctx->y1 == NULL || ctx->z1 == NULL || ctx->t1 == NULL) {
+		return 0;
+	}
+	for (int i = 0; i < 64; i++) {
+		ctx->x1[i] = (uint32_t *) malloc(64 * sizeof(uint32_t));
+		ctx->y1[i] = (uint32_t *) malloc(64 * sizeof(uint32_t));
+		ctx->z1[i] = (uint32_t *) malloc(64 * sizeof(uint32_t));
+		if (ctx->x1[i] == NULL || ctx->y1[i] == NULL || ctx->z1[i] == NULL) {
+			return 0;
+		}
+	}
+	return 1;
+}
+
+void FFT_CTX_clear(FFT_CTX *ctx) {
+	if (ctx == NULL) {
+		return;
+	}
+	for (int i = 0; i < 64; i++) {
+		memset((void *) ctx->x1[i], 0, 64 * sizeof(uint32_t));
+		memset((void *) ctx->y1[i], 0, 64 * sizeof(uint32_t));
+		memset((void *) ctx->z1[i], 0, 64 * sizeof(uint32_t));
+	}
+	memset((void *) ctx->t1, 0, 64 * sizeof(uint32_t));
+}
+
+void FFT_CTX_free(FFT_CTX *ctx) {
+	if (ctx == NULL) {
+		return;
+	}
+	for (int i = 0; i < 64; i++) {
+		free(ctx->x1[i]);
+		free(ctx->y1[i]);
+		free(ctx->z1[i]);
+	}
+	free(ctx->x1);
+	free(ctx->y1);
+	free(ctx->z1);
+	free(ctx->t1);
+}
+
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/fft.h openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/fft.h
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/fft.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/fft.h	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,32 @@
+/* This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * See LICENSE for complete information.
+ */
+
+#ifndef _FFT_H_
+#define _FFT_H_
+
+#include <stdint.h>
+
+struct fft_ctx {
+	uint32_t **x1;
+	uint32_t **y1;
+	uint32_t **z1;
+	uint32_t *t1;
+};
+typedef struct fft_ctx FFT_CTX;
+
+int FFT_CTX_init(FFT_CTX *ctx);
+void FFT_CTX_clear(FFT_CTX *ctx);
+void FFT_CTX_free(FFT_CTX *ctx);
+
+void FFT_mul(uint32_t *z, const uint32_t *x, const uint32_t *y, FFT_CTX *ctx);
+void FFT_add(uint32_t *z, const uint32_t *x, const uint32_t *y);
+
+#endif /* _FFT_H_ */
+
